ghost = {}

ghost.values = function()
	return {
		anim_state = 0,
		walk = 0,
		afraid = false,
	}
end

ghost.update = function(vals,dt)
	vals.anim_state = vals.anim_state + dt
	if vals.anim_state > 1 then
		vals.anim_state = vals.anim_state - 1
	end
	return vals
end

ghost.animate = function(x,y,vals,scale)
	local anim = vals.anim_state
	
	if anim <= 0.5 then
		anim = anim * 0.3
	else
		anim = 0.5 * 0.3 - (anim - 0.5) * 0.3
	end
	
	if vals.afraid == true then
		love.graphics.setColor(0,0,255,255) -- Blue Filler
		love.graphics.circle("fill",x,y,scale,16) -- Doesnt have to be that precise
	else
		love.graphics.setColor(255,0,0,255) -- Red Filler
		love.graphics.circle("fill",x,y,scale,16) -- Doesnt have to be that precise
	end
	
	if vals.walk == 0 or vals.walk == 4 then -- YOU'RE DONE HERE! I REPEAT YOU'RE DONE HERE! DO NOT SPEND MORE TIME WITH THIS CODE IT'S FIXED ALREADY!
		
		if vals.afraid == true then
			love.graphics.setColor(255,255,255,255)
		else
			love.graphics.setColor(0,0,0,255) -- Mouth
		end
		
		lsp = {}
		lsp[1] = {}
		lsp[2] = {}
		lsp[3] = {}
		if vals.afraid == true then
			lsp[1][1] = {x = x + math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			lsp[1][2] = {x = x,y = y}
			lsp[1][3] = {x = x - math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			
			lsp[2][1] = {x = x + math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			lsp[2][2] = {x = x - scale / 1.15,y = y - scale / 6}
			lsp[2][3] = {x = x,y = y - scale / 7}
			
			lsp[3][1] = {x = x - math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			lsp[3][2] = {x = x + scale / 1.15,y = y - scale / 6}
			lsp[3][3] = {x = x,y = y - scale / 7}
		else
			lsp[1][1] = {x = x - scale / 1.1, y = y - (anim * scale)}
			lsp[1][2] = {x = x,y = y + scale / 1.2}
			lsp[1][3] = {x = x + scale / 1.1,y = y - (anim * scale)}
			
			lsp[2][1] = {x = x - scale / 1.1,y = y - (anim * scale)}
			lsp[2][2] = {x = x - scale / 1.15,y = y + scale / 1.15}
			lsp[2][3] = {x = x,y = y + scale / 1.2}
			
			lsp[3][1] = {x = x + scale / 1.1,y = y - (anim * scale)}
			lsp[3][2] = {x = x + scale / 1.15,y = y + scale / 1.15}
			lsp[3][3] = {x = x,y = y + scale / 1.2}
		end
		
		love.graphics.setLineWidth(0.05 * scale) -- Sets approapriate line width
		amnag.graphics.bend(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,16)
		amnag.graphics.bend(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,16)
		amnag.graphics.bend(lsp[3][1].x,lsp[3][1].y,lsp[3][2].x,lsp[3][2].y,lsp[3][3].x,lsp[3][3].y,16)
		
		local teeth = {} -- Calculates Teeth Points
		
		for i = 0, 8 do
			teeth[i] = {}
			teeth[i][1] = {}
			teeth[i][1].x,teeth[i][1].y = amnag.math.bendpoint(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,i / 8)
			
			teeth[i][3] = {}
			if i <= 4 then
				teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,i / 4)
			else
				teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(lsp[3][1].x,lsp[3][1].y,lsp[3][2].x,lsp[3][2].y,lsp[3][3].x,lsp[3][3].y,1 - (i - 4) / 4)
			end
			
			teeth[i][2] = {}
			teeth[i][2].x = (teeth[i][1].x + teeth[i][3].x) / 2
			teeth[i][2].y = (teeth[i][1].y + teeth[i][3].y) / 2
		end
		
		for i = 1, 8 do -- Teeth
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 4 or i == 7 then
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 3 or i == 5 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][1].x, teeth[i - 1][1].y,
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i][2].x, teeth[i][2].y,
				teeth[i][1].x, teeth[i][1].y,
			})
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 2 or i == 6 then -- set botten color
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 4 or i == 8 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i - 1][3].x, teeth[i - 1][3].y,
				teeth[i][3].x, teeth[i][3].y,
				teeth[i][2].x, teeth[i][2].y,
			})
			
		end
		if vals.afraid == true then
			love.graphics.setColor(255,255,255,255)
		else
			love.graphics.setColor(0,0,0,255) -- Teeth Separator line
		end
		love.graphics.line(teeth[1][2].x, teeth[1][2].y,teeth[0][2].x, teeth[0][2].y)
		for i = 1, 7 do
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i + 1][2].x, teeth[i + 1][2].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][1].x, teeth[i][1].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][3].x, teeth[i][3].y)
		end
		
		-- Eyes
		love.graphics.setColor(255,255,255,255) -- Eye Filler Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
		else
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,16)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,16)
		end
		
		love.graphics.setColor(0,0,0,255) -- Iris Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3.5,scale * 0.2,scale * 0.15,16)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3.5,scale * 0.2,scale * 0.15,16)
		else
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3.5,scale * 0.15,scale * 0.2,16)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3.5,scale * 0.15,scale * 0.2,16)
		end
		
		love.graphics.setLineWidth(0.025 * scale) -- Sets approapriate line width
		if vals.afraid == false then
			love.graphics.setColor(255,0,0,255) -- Eye lid Color
		
			amnag.graphics.partoval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,math.pi - 3,-math.pi,8)
			amnag.graphics.partoval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,-math.pi + 3,-math.pi,8)
			
			love.graphics.setColor(0,0,0,255) -- Eye lid line Color
			love.graphics.line(x - scale / 2.2 + math.cos(math.pi - 3) * scale * 0.3,y - scale / 3 + math.sin(math.pi - 3) * scale * 0.4 - (anim * scale / 2),x - scale / 2.2 + math.cos(-3) * scale * 0.3,y - scale / 3 + math.sin(-3) * scale * 0.4 - (anim * scale / 2))
			love.graphics.line(x + scale / 2.2 + math.cos(math.pi - 3) * scale * 0.3,y - scale / 3 + math.sin(-math.pi + 3) * scale * 0.4 - (anim * scale / 2),x + scale / 2.2 + math.cos(-3) * scale * 0.3,y - scale / 3 + math.sin(math.pi - (math.pi - 3)) * scale * 0.4 - (anim * scale / 2))
		end
		
		-- Eye outline Color
		if vals.afraid == true then
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
		else
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
		end
		
		love.graphics.setColor(0,0,0,255) -- Outline
		love.graphics.setLineWidth(0.1 * scale) -- Sets approapriate line width
		love.graphics.circle("line",x,y,scale,64)
		
	elseif vals.walk == 1 then -- WALKING LEFT
		
		if vals.afraid == true then
			love.graphics.setColor(255,255,255,255)
		else
			love.graphics.setColor(0,0,0,255) -- Mouth Line
		end
		
		lsp = {}
		lsp[1] = {}
		lsp[2] = {}
		--lsp[3] = {}
		
		if vals.afraid == true then
			lsp[1][1] = {x = x + math.cos(math.pi * 1.05) * scale,y = y + math.sin(math.pi * 1.05) * scale}
			lsp[1][2] = {x = x + scale * 0.25,y = y}
			lsp[1][3] = {x = x + scale / 2.2,y = y + scale * 0.65 - (anim * scale)}
			
			lsp[2][1] = {x = x + math.cos(math.pi * 0.85) * scale,y = y + math.sin(math.pi * 0.85) * scale}
			lsp[2][2] = {x = x + scale / 4,y = y + scale / 1.85}
			lsp[2][3] = {x = x + scale / 2.2,y = y + scale * 0.65 - (anim * scale)}
			
			--lsp[3][1] = {x = x - math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			--lsp[3][2] = {x = x + scale / 1.15,y = y - scale / 6}
			--lsp[3][3] = {x = x,y = y - scale / 7}
		else
			lsp[1][1] = {x = x + math.cos(math.pi * 0.9) * scale,y = y + math.sin(math.pi * 0.9) * scale}
			lsp[1][2] = {x = x,y = y + scale / 1.8}
			lsp[1][3] = {x = x + scale / 2.2,y = y - (anim * scale)}
			
			lsp[2][1] = {x = x + math.cos(math.pi * 0.75) * scale,y = y + math.sin(math.pi * 0.75) * scale}
			lsp[2][2] = {x = x + scale / 1.15,y = y + scale / 1.15}
			lsp[2][3] = {x = x + scale / 2.2,y = y - (anim * scale)}
			
			--lsp[3][1] = {x = x + scale / 1.1,y = y - (anim * scale)}
			--lsp[3][2] = {x = x + scale / 1.15,y = y + scale / 1.15}
			--lsp[3][3] = {x = x,y = y + scale / 1.2}
		end
		
		love.graphics.setLineWidth(0.05 * scale) -- Sets approapriate line width
		amnag.graphics.bend(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,16)
		--amnag.graphics.bend(x - scale / 1.1,y - (anim * scale),x - scale / 1.15,y + scale / 1.15,x ,y + scale / 1.2,16)
		amnag.graphics.bend(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,16)
		
		local teeth = {} -- Calculates Teeth Points
		
		for i = 0, 5 do
			teeth[i] = {}
			teeth[i][1] = {}
			teeth[i][1].x,teeth[i][1].y = amnag.math.bendpoint(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,i / 5)
			
			teeth[i][3] = {}
			--if i <= 4 then
				teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,i / 5)
			--else
			--	teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(x + scale / 1.1,y - (anim * scale),x + scale / 1.15,y + scale / 1.15,x ,y + scale / 1.2,1 - (i - 4) / 4)
			--end
			
			teeth[i][2] = {}
			teeth[i][2].x = (teeth[i][1].x + teeth[i][3].x) / 2
			teeth[i][2].y = (teeth[i][1].y + teeth[i][3].y) / 2
		end
		
		for i = 1, 5 do -- Teeth
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 4 then -- set top color
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 2 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][1].x, teeth[i - 1][1].y,
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i][2].x, teeth[i][2].y,
				teeth[i][1].x, teeth[i][1].y,
			})
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 3 then -- set botten color
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 1 or i == 5 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i - 1][3].x, teeth[i - 1][3].y,
				teeth[i][3].x, teeth[i][3].y,
				teeth[i][2].x, teeth[i][2].y,
			})
			
		end
		if vals.afraid == true then -- set top color
			love.graphics.setColor(255,255,255,255) -- Afraid teeth
		else
			love.graphics.setColor(0,0,0,255) -- Teeth Separator line
		end
		love.graphics.line(teeth[1][2].x, teeth[1][2].y,teeth[0][2].x, teeth[0][2].y)
		for i = 1, 4 do
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i + 1][2].x, teeth[i + 1][2].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][1].x, teeth[i][1].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][3].x, teeth[i][3].y)
		end
		
		-- Eyes
		love.graphics.setColor(255,255,255,255) -- Eye Filler Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
		else
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,16)
		end
		
		love.graphics.setColor(0,0,0,255) -- Iris Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x - scale / 3,y - scale / 3.25,scale * 0.2,scale * 0.15,16)
		else
			amnag.graphics.oval("fill",x - scale / 1.8,y - scale / 3.5,scale * 0.15,scale * 0.2,16)
		end
		
		love.graphics.setLineWidth(0.025 * scale) -- Sets approapriate line width
		if vals.afraid == false then
			love.graphics.setColor(255,0,0,255) -- Eye lid Color
			amnag.graphics.partoval("fill",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,-math.pi + 3,-math.pi,8)
		
			love.graphics.setColor(0,0,0,255) -- Eye lid line Color
			love.graphics.line(x - scale / 2.2 + math.cos(math.pi - 3) * scale * 0.3,y - scale / 3 + math.sin(-math.pi + 3) * scale * 0.4 - (anim * scale / 2),x - scale / 2.2 + math.cos(-3) * scale * 0.3,y - scale / 3 + math.sin(math.pi - (math.pi - 3)) * scale * 0.4 - (anim * scale / 2))
		end
		
		-- Eye outline Color
		if vals.afraid == true then
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
		else
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
		end
		
		love.graphics.setColor(0,0,0,255) -- Outline
		love.graphics.setLineWidth(0.1 * scale) -- Sets approapriate line width
		love.graphics.circle("line",x,y,scale,64)
		
	elseif vals.walk == 2 then
		
		-- Eyes
		
		love.graphics.setLineWidth(0.025 * scale) -- Sets approapriate line width
		
		-- Eye outline Color
		if vals.afraid == true then
			love.graphics.setColor(0,0,255,255)
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 1.7 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 1.7 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
			love.graphics.setColor(0,0,0,255)
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 1.7 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 1.7 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
			love.graphics.setColor(0,0,255,255) -- Blue Filler
			love.graphics.circle("fill",x,y,scale,16) -- Doesnt have to be that precise
		else
			love.graphics.setColor(255,0,0,255)
			amnag.graphics.oval("fill",x - scale / 2.2,y - scale / 1.8 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 1.8 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
			love.graphics.setColor(0,0,0,255)
			amnag.graphics.oval("line",x - scale / 2.2,y - scale / 1.8 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 1.8 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
			love.graphics.setColor(255,0,0,255) -- Red Filler
			love.graphics.circle("fill",x,y,scale,16) -- Doesnt have to be that precise
		end
		
		love.graphics.setColor(0,0,0,255) -- Outline
		love.graphics.setLineWidth(0.1 * scale) -- Sets approapriate line width
		love.graphics.circle("line",x,y,scale,64)
	
	elseif vals.walk == 3 then
		
		if vals.afraid == true then
			love.graphics.setColor(255,255,255,255)
		else
			love.graphics.setColor(0,0,0,255) -- Mouth Line
		end
		
		lsp = {}
		lsp[1] = {}
		lsp[2] = {}
		--lsp[3] = {}
		
		if vals.afraid == true then
			lsp[1][1] = {x = x - math.cos(math.pi * 1.05) * scale,y = y + math.sin(math.pi * 1.05) * scale}
			lsp[1][2] = {x = x - scale * 0.25,y = y}
			lsp[1][3] = {x = x - scale / 2.2,y = y + scale * 0.65 - (anim * scale)}
			
			lsp[2][1] = {x = x - math.cos(math.pi * 0.85) * scale,y = y + math.sin(math.pi * 0.85) * scale}
			lsp[2][2] = {x = x - scale / 4,y = y + scale / 1.85}
			lsp[2][3] = {x = x - scale / 2.2,y = y + scale * 0.65 - (anim * scale)}
			
			--lsp[3][1] = {x = x - math.cos(math.pi *(anim + 0.75)) * scale * 0.9, y = y + math.sin(math.pi *(anim + 0.75)) * scale * 0.9}
			--lsp[3][2] = {x = x + scale / 1.15,y = y - scale / 6}
			--lsp[3][3] = {x = x,y = y - scale / 7}
		else
			lsp[1][1] = {x = x - math.cos(math.pi * 0.9) * scale,y = y + math.sin(math.pi * 0.9) * scale}
			lsp[1][2] = {x = x,y = y + scale / 1.8}
			lsp[1][3] = {x = x - scale / 2.2,y = y - (anim * scale)}
			
			lsp[2][1] = {x = x - math.cos(math.pi * 0.75) * scale,y = y + math.sin(math.pi * 0.75) * scale}
			lsp[2][2] = {x = x - scale / 1.15,y = y + scale / 1.15}
			lsp[2][3] = {x = x - scale / 2.2,y = y - (anim * scale)}
			
			--lsp[3][1] = {x = x + scale / 1.1,y = y - (anim * scale)}
			--lsp[3][2] = {x = x + scale / 1.15,y = y + scale / 1.15}
			--lsp[3][3] = {x = x,y = y + scale / 1.2}
		end
		
		love.graphics.setLineWidth(0.05 * scale) -- Sets approapriate line width
		amnag.graphics.bend(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,16)
		--amnag.graphics.bend(x - scale / 1.1,y - (anim * scale),x - scale / 1.15,y + scale / 1.15,x ,y + scale / 1.2,16)
		amnag.graphics.bend(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,16)
		
		local teeth = {} -- Calculates Teeth Points
		
		for i = 0, 5 do
			teeth[i] = {}
			teeth[i][1] = {}
			teeth[i][1].x,teeth[i][1].y = amnag.math.bendpoint(lsp[1][1].x,lsp[1][1].y,lsp[1][2].x,lsp[1][2].y,lsp[1][3].x,lsp[1][3].y,i / 5)
			
			teeth[i][3] = {}
			--if i <= 4 then
				teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(lsp[2][1].x,lsp[2][1].y,lsp[2][2].x,lsp[2][2].y,lsp[2][3].x,lsp[2][3].y,i / 5)
			--else
			--	teeth[i][3].x,teeth[i][3].y = amnag.math.bendpoint(x + scale / 1.1,y - (anim * scale),x + scale / 1.15,y + scale / 1.15,x ,y + scale / 1.2,1 - (i - 4) / 4)
			--end
			
			teeth[i][2] = {}
			teeth[i][2].x = (teeth[i][1].x + teeth[i][3].x) / 2
			teeth[i][2].y = (teeth[i][1].y + teeth[i][3].y) / 2
		end
		
		for i = 1, 5 do -- Teeth
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 2 then -- set top color
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 1 or i == 3 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][1].x, teeth[i - 1][1].y,
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i][2].x, teeth[i][2].y,
				teeth[i][1].x, teeth[i][1].y,
			})
			if vals.afraid == true then -- set top color
				love.graphics.setColor(0,186,0,255) -- Afraid teeth
			elseif i == 4 then -- set botten color
				love.graphics.setColor(255,255,0,255) -- Golden
			elseif i == 2 then
				love.graphics.setColor(0,0,0,255) -- Black ( no teeth )
			else
				love.graphics.setColor(255,255,255,255) -- Normal teeth
			end
			love.graphics.polygon("fill",{
				teeth[i - 1][2].x, teeth[i - 1][2].y,
				teeth[i - 1][3].x, teeth[i - 1][3].y,
				teeth[i][3].x, teeth[i][3].y,
				teeth[i][2].x, teeth[i][2].y,
			})
			
		end
		if vals.afraid == true then
			love.graphics.setColor(255,255,255,255)
		else
			love.graphics.setColor(0,0,0,255) -- Teeth Separator line
		end
		love.graphics.line(teeth[1][2].x, teeth[1][2].y,teeth[0][2].x, teeth[0][2].y)
		for i = 1, 4 do
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i + 1][2].x, teeth[i + 1][2].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][1].x, teeth[i][1].y)
			love.graphics.line(teeth[i][2].x, teeth[i][2].y,teeth[i][3].x, teeth[i][3].y)
		end
		
		-- Eyes
		love.graphics.setColor(255,255,255,255) -- Eye Filler Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,16)
		else
			amnag.graphics.oval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,16)
		end
		
		love.graphics.setColor(0,0,0,255) -- Iris Color
		if vals.afraid == true then
			amnag.graphics.oval("fill",x + scale / 3,y - scale / 3.25,scale * 0.2,scale * 0.15,16)
		else
			amnag.graphics.oval("fill",x + scale / 1.8,y - scale / 3.5,scale * 0.15,scale * 0.2,16)
		end
		
		love.graphics.setLineWidth(0.025 * scale) -- Sets approapriate line width
		if vals.afraid == false then
			love.graphics.setColor(255,0,0,255) -- Eye lid Color
		
			amnag.graphics.partoval("fill",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,math.pi - 3,-math.pi,8)
		
			love.graphics.setColor(0,0,0,255) -- Eye lid line Color
			love.graphics.line(x + scale / 2.2 + math.cos(math.pi - 3) * scale * 0.3,y - scale / 3 + math.sin(math.pi - 3) * scale * 0.4 - (anim * scale / 2),x + scale / 2.2 + math.cos(-3) * scale * 0.3,y - scale / 3 + math.sin(-3) * scale * 0.4 - (anim * scale / 2))
		end
		
		-- Eye outline Color
		if vals.afraid == true then
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.4,scale * 0.3,32)
		else
			amnag.graphics.oval("line",x + scale / 2.2,y - scale / 3 - (anim * scale / 2),scale * 0.3,scale * 0.4,32)
		end
		
		love.graphics.setColor(0,0,0,255) -- Outline
		love.graphics.setLineWidth(0.1 * scale) -- Sets approapriate line width
		love.graphics.circle("line",x,y,scale,64)
		
	elseif vals.walk == 4 then
		
	end
end
