
amnag.graphics = {}

amnag.graphics.bend = function(x1,y1,x2,y2,x3,y3,segments)
	--local segments = 20;
		
	local points = {x,y};
	
	for j = 1, segments+1, 1 do
	
		local pt = {};
		pt.x = 0;
		pt.y = 0;
		table.insert(points,pt);
		--table.insert(points,pt.y);
		
	end
	
	for currentIndex = 1, segments+1, 1 do
		local t = (currentIndex-1.0) / segments
		local a = (1.0 - t) * (1.0 - t);
		local b = 2.0 * t * (1.0 - t);
		local c = t * t;
		
		local x = a * x1 + b * x2 + c * x3;
		local y = a * y1 + b * y2 + c * y3;
		
		points[currentIndex].x = x;
		points[currentIndex].y = y;
		
	end

	for currentIndex = 1, segments, 1 do
		local nextIndex = currentIndex + 1;
		--print("Drawing line segment from " .. points[currentIndex].x .. ", " .. points[currentIndex].y .. " to " .. points[nextIndex].x .. ", " .. points[nextIndex].y);
		love.graphics.line(points[currentIndex].x, points[currentIndex].y, points[nextIndex].x, points[nextIndex].y);
		--line.width = 3
	end
end

amnag.graphics.oval = function(drawMode,x,y,sizex,sizey,segments)
	drawMode = drawMode or "fill"
	segments = segments or 16
	rotation = rotation or 0
	
	local tbl = {}
	
	for i = 1, segments do
		table.insert(tbl,x + math.cos(i * (math.pi * 2 / segments)) * sizex)
		table.insert(tbl,y + math.sin(i * (math.pi * 2 / segments)) * sizey)
	end
	
	love.graphics.polygon(drawMode,tbl)
end

amnag.graphics.partoval = function(drawMode,x,y,sizex,sizey,startrad,endrad,segments)
	drawMode = drawMode or "fill"
	segments = segments or 16
	rotation = rotation or 0
	
	local tbl = {}
	
	local pipart = endrad
	
	for i = 0, segments do
		table.insert(tbl,x + math.cos(startrad + i * (pipart / segments)) * sizex)
		table.insert(tbl,y + math.sin(startrad + i * (pipart / segments)) * sizey)
	end
	
	if drawMode == "fill" then
		love.graphics.polygon(drawMode,tbl)
	else
		for i = 1, table.getn(tbl) / 2 -1 do
			love.graphics.line(tbl[i * 2 - 1],tbl[i * 2],tbl[(i+1) * 2 - 1],tbl[(i+1) * 2])
		end
	end
end

amnag.graphics.newLightning = function(x,y,length,mint,maxt,scal)
	local tbl = {}
	
	local ext = false
	
	local tmpvalues = {}
	
	local i = 1
	
	local mode = 1
	
	local tmpx,tmpy = x,y
	
	tmpvalues[1] = {}
	tmpvalues[1].spread = math.random(mint,maxt)
	tmpvalues[1].spreaded = 0
	tmpvalues[1].x = tmpx
	tmpvalues[1].y = tmpy
	
	repeat
		if mode == 1 then
			if i >= length or tmpvalues[i].spreaded >= tmpvalues[i].spread then
				if i == 1 then
					ext = true
				else
					i = i - 1
				end
			else
				tmpvalues[i + 1] = {}
				tmpvalues[i + 1].spread = math.random(mint,maxt)
				tmpvalues[i + 1].spreaded = 0
				tmpvalues[i + 1].x = tmpvalues[i].x + math.random(-1.0 * scal,1.0 * scal)
				tmpvalues[i + 1].y = tmpvalues[i].y + math.random(1.0 * scal,1.5 * scal)
				
				tmpvalues[i].spreaded = tmpvalues[i].spreaded + 1
				
				table.insert(tbl,{tmpvalues[i + 1].x,tmpvalues[i + 1].y,tmpvalues[i].x,tmpvalues[i].y})
				
				i = i + 1
			end
		elseif mode == 2 then
			
		end
	until ext == true
	
	return tbl
end

amnag.graphics.drawLightning = function(light,size)
	for i = 1, table.getn(light) do
		love.graphics.line(light[i][1],light[i][2],light[i][3],light[i][4])
	end
end
