
amnag = {}

screen = {
	width = love.graphics.getWidth(),
	height = love.graphics.getHeight(),
}

require "ammath"
require "graphics"
require "ghost"
require "pathman"
require "AI"
require "extras"
require "map"

function love.load()
	--love.graphics.setPixelEffect(amnag.darkness)
	
	arrw = {}
	
	mouse_x = 0
	mouse_y = 0
	tatalt = 0
	love.graphics.setFont(love.graphics.newFont(12))
	mode = false
	gamemode = "menu"
	score = 0
	
	mapselection = {}
	for i = 1, table.getn(amnag.map) do
		mapselection[i] = {
			x = -100 + 200 * i,
			y = 225,
			width = 200,
			height = 125,
			text = {
				held = "LEVEL " .. i .. "!",
				left = "Level " .. i .. "?",
			},
		}
	end
	mapselection.pick = 1
	playbutton = {
		{
			x = 690,
			y = 540,
			width = 100,
			height = 50,
			text = {
				held = "PLAY!",
				left = "Play?",
			},
			held = false,
			func = function()
				startgame(mapselection.pick,1,playbuttons.pick)
			end,
		},
		{
			x = 10,
			y = 540,
			width = 100,
			height = 50,
			text = {
				held = "BACK!",
				left = "Back?",
			},
			held = false,
			func = function()
				gamemode = "menu"
			end,
		},
	}
	playbuttons = {
		{
			x = 100,
			y = 20,
			width = 150,
			height = 50,
			text = {
				held = "LOSER LVL!",
				left = "1?",
			},
			held = false,
		},
		{
			x = 250,
			y = 20,
			width = 150,
			height = 50,
			text = {
				held = "EASY!",
				left = "2?",
			},
			held = false,
		},
		{
			x = 400,
			y = 20,
			width = 150,
			height = 50,
			text = {
				held = "NORMAL!",
				left = "3?",
			},
			held = false,
		},
		{
			x = 550,
			y = 20,
			width = 150,
			height = 50,
			text = {
				held = "HARD!",
				left = "4?",
			},
			held = false,
		},
		{
			x = 100,
			y = 70,
			width = 150,
			height = 50,
			text = {
				held = "HARDER!",
				left = "5?",
			},
			held = false,
		},
		{
			x = 250,
			y = 70,
			width = 150,
			height = 50,
			text = {
				held = "DEVIL NUMBER!",
				left = "6?",
			},
			held = false,
		},
		{
			x = 400,
			y = 70,
			width = 150,
			height = 50,
			text = {
				held = "LUCKY NUMBER!",
				left = "7?",
			},
			held = false,
		},
		{
			x = 550,
			y = 70,
			width = 150,
			height = 50,
			text = {
				held = "INFINITE ON THE SIDE!",
				left = "8?",
			},
			held = false,
		},
	}
	playbuttons.pick = 3
	playspeed = {
		x = 100,
		y = 170,
		width = 600,
		value = 1,
		lvalue = 0.5,
		tvalue = 2,
		move = function(t)
			playspeed.value = math.min(2,math.max(0.5,math.lerp(playspeed.lvalue,playspeed.tvalue,t)))
		end,
		held = false,
	}
	buttons = {
		{
			x = 350,
			y = 190,
			width = 100,
			height = 50,
			text = {
				held = "PLAY!",
				left = "Play?",
			},
			held = false,
			func = function()
				gamemode = "play"
			end,
		},
		{
			x = 350,
			y = 250,
			width = 100,
			height = 50,
			text = {
				held = "CREDITS!",
				left = "Credits?",
			},
			held = false,
			func = function()
				gamemode = "credits"
			end,
		},
		{
			x = 10,
			y = 540,
			width = 100,
			height = 50,
			text = {
				held = "NOOOOOOO!",
				left = "Exit?",
			},
			held = false,
			func = function()
				love.event.push("quit")
			end,
		},
		{
			x = 350,
			y = 310,
			width = 100,
			height = 50,
			text = {
				held = "EXTRAS!",
				left = "Extras?",
			},
			held = false,
			func = function()
				gamemode = "extras"
			end,
		},
	}
	credbutton = {
		x = 10,
		y = 540,
		width = 100,
		height = 50,
		text = {
			held = "BACK!",
			left = "Back?",
		},
		held = false,
		func = function()
			gamemode = "menu"
		end,
	}
	credits = {
		"Programming",
		"",
		"Tommi Israelsson",
		"",
		"",
		"Art",
		"",
		"Tommi Israelsson",
		"Seva Larsson",
		"",
		"",
		"Art Coding",
		"",
		"Tommi Israelsson",
		"",
		"",
		"Other Stuff",
		"",
		"Tommi Israelsson",
		"",
		"",
		"Thanks to:",
		"",
		"Tommi Israelsson",
		"For staying focused enough to actually finish something.",
		"",
		"Seva Larsson",
		"For some art that was animated by Tommi Israelsson.",
		"",
		"Simon Wellander",
		"For making a website for me.",
		"",
		"YOU!",
		"For reading this.",
		"",
		"ME!",
		"For writing this.",
		"",
		"Whoever hold the copyright to pac-man",
		"For not suing me.",
	}
	credits.scroll = 0
	credits.tmpscroll = 0
	credits.mouseclick = {x = 0,y = 0}
	credits.held = false
	block = {}
	block[0] = {
		true,
		true,
		true,
		true,
	}
	block[1] = {
		false,
		true,
		true,
		true,
	}
	block[2] = {
		false,
		false,
		true,
		true,
	}
	block[3] = {
		false,
		true,
		false,
		true,
	}
	block[4] = {
		false,
		true,
		true,
		false,
	}
	block[5] = {
		true,
		false,
		true,
		true,
	}
	block[6] = {
		true,
		false,
		false,
		true,
	}
	block[7] = {
		true,
		false,
		true,
		false,
	}
	block[8] = {
		true,
		true,
		false,
		true,
	}
	block[9] = {
		true,
		true,
		false,
		false,
	}
	block[10] = {
		true,
		true,
		true,
		false,
	}
	block[11] = {
		false,
		false,
		false,
		true,
	}
	block[12] = {
		false,
		false,
		true,
		false,
	}
	block[13] = {
		false,
		true,
		false,
		false,
	}
	block[14] = {
		true,
		false,
		false,
		false,
	}
end

function math.lerp(a,b,t)
	return a + (b - a) * t
end

function math.delerp(a,b,g)
	-- g = a + (b - a) * t
	-- g - a = (b - a) * t
	-- (g - a) / (b - a) = t
	-- t = a + (b - a) / g
	return (g - a) / (b - a)
end

function startgame(mmap,pmap,emap)
	score = 0
	field = nil
	points = nil
	pacmans = nil
	scale = nil
	pathman = nil
	field = {}
	points = {}
	pacmans = {}
	scale = {}
	pathman = {}
	fielddata,pointdata,pacdata,scale,pathmandata = amnag.map.get(mmap,pmap,emap)
	pathman.x = pathmandata.x
	pathman.y = pathmandata.y
	pathman.dis = pathmandata.dis
	pathman.walk = pathmandata.walk
	pathman.wantwalk = pathmandata.wantwalk
	pathman.chasetime = pathmandata.chasetime
	pathman.values = pathmandata.values
	pathman.pathing = pathmandata.pathing
	for i = 1, table.getn(pacdata) do
		pacmans[i] = {}
		pacmans[i].x = pacdata[i].x
		pacmans[i].y = pacdata[i].y
		pacmans[i].dis = pacdata[i].dis
		pacmans[i].walk = pacdata[i].walk
		pacmans[i].values = pacdata[i].values
		pacmans[i].navigator = {}
	end
	for i = 1, table.getn(fielddata) do
		field[i] = {}
		for j = 1, table.getn(fielddata[i]) do
			field[i][j] = fielddata[i][j]
		end
	end
	for i = 1, table.getn(pointdata) do
		points[i] = {}
		for j = 1, table.getn(pointdata[i]) do
			points[i][j] = pointdata[i][j]
		end
	end
	gamemode = "game"
end

function posWithWalkDis(x,y,walk,dis)
	
	if walk == 1 then
		x = x - dis
	elseif walk == 2 then
		y = y - dis
	elseif walk == 3 then
		x = x + dis
	elseif walk == 4 then
		y = y + dis
	end
	
	return x,y
end

function love.update(dt)
	--print(math.lerp(0.5,2.0,0.5) .. "  " .. math.delerp(0.5,2.0,math.lerp(0.5,2.0,0.5)))
	mouse_x = love.mouse.getX()
	mouse_y = love.mouse.getY()
	tatalt = tatalt + dt
	
	lastotalt = math.mod(tatalt,1)
	if gamemode == "game" then
		if pathman.chasetime > 0 then
			pathman.chasetime = pathman.chasetime - dt
			if pathman.chasetime < 0 then pathman.chasetime = 0 end
		end
		if love.keyboard.isDown("left") then
			pathman.wantwalk = 1
			pathman.pathing = false
		elseif love.keyboard.isDown("up") then
			pathman.wantwalk = 2
			pathman.pathing = false
		elseif love.keyboard.isDown("right") then
			pathman.wantwalk = 3
			pathman.pathing = false
		elseif love.keyboard.isDown("down") then
			pathman.wantwalk = 4
			pathman.pathing = false
		end
		if pathman.pathing == true then
			AI.calculate({pathman},field,{x = pathman.path[1],y = pathman.path[2],chasetime = 0},dt)
		else
			if pathman.walk > 0 then
				if points[pathman.x][pathman.y] == 1 then
				--	points[pathman.x][pathman.y] = 0
				elseif points[pathman.x][pathman.y] == 2 then
				--	points[pathman.x][pathman.y] = 0
				--	pathman.chasetime = 10
				end
				pathman.dis = pathman.dis + (dt * 2)
				if pathman.dis >= 1 then
					pathman.dis = pathman.dis - 1
					if pathman.walk == 1 then
						if block[field[pathman.x][pathman.y]][pathman.walk] == true then
							pathman.x = pathman.x - 1
							if pathman.x == 0 then
								pathman.x = scale.datax
							elseif pathman.x == scale.datax + 1 then
								pathman.x = 1
							end
							if block[field[pathman.x][pathman.y]][pathman.wantwalk] == true then
								if pathman.wantwalk == pathman.walk then else
									pathman.walk = pathman.wantwalk
								end
							elseif block[field[pathman.x][pathman.y]][pathman.walk] == false then
								pathman.walk = 0
							end
						else
							pathman.dis = 0
							pathman.walk = 0
						end
					elseif pathman.walk == 2 then
						if block[field[pathman.x][pathman.y]][pathman.walk] == true then
							pathman.y = pathman.y - 1
							if pathman.y == 0 then
								pathman.y = scale.datay
							elseif pathman.y == scale.datay + 1 then
								pathman.y = 1
							end
							if block[field[pathman.x][pathman.y]][pathman.wantwalk] == true then
								if pathman.wantwalk == pathman.walk then else
									pathman.walk = pathman.wantwalk
								end
							elseif block[field[pathman.x][pathman.y]][pathman.walk] == false then
								pathman.walk = 0
							end
						else
							pathman.dis = 0
							pathman.walk = 0
						end
					elseif pathman.walk == 3 then
						if block[field[pathman.x][pathman.y]][pathman.walk] == true then
							pathman.x = pathman.x + 1
							if pathman.x == 0 then
								pathman.x = scale.datax
							elseif pathman.x == scale.datax + 1 then
								pathman.x = 1
							end
							if block[field[pathman.x][pathman.y]][pathman.wantwalk] == true then
								if pathman.wantwalk == pathman.walk then else
									pathman.walk = pathman.wantwalk
								end
							elseif block[field[pathman.x][pathman.y]][pathman.walk] == false then
								pathman.walk = 0
							end
						else
							pathman.dis = 0
							pathman.walk = 0
						end
					elseif pathman.walk == 4 then
						if block[field[pathman.x][pathman.y]][pathman.walk] == true then
							pathman.y = pathman.y + 1
							if pathman.y == 0 then
								pathman.y = scale.datay
							elseif pathman.y == scale.datay + 1 then
								pathman.y = 1
							end
							if block[field[pathman.x][pathman.y]][pathman.wantwalk] == true then
								if pathman.wantwalk == pathman.walk then else
									pathman.walk = pathman.wantwalk
								end
							elseif block[field[pathman.x][pathman.y]][pathman.walk] == false then
								pathman.walk = 0
							end
						else
							pathman.dis = 0
							pathman.walk = 0
						end
					end
				else
					if pathman.wantwalk == 1 and pathman.walk == 3 then
						pathman.x = pathman.x + 1
						if pathman.x > scale.datax then pathman.x = pathman.x - scale.datax end
						pathman.dis = 1 - pathman.dis
						pathman.walk = pathman.wantwalk
					elseif pathman.wantwalk == 3 and pathman.walk == 1 then
						pathman.x = pathman.x - 1
						if pathman.x < 0 then pathman.x = pathman.x + scale.datax end
						pathman.dis = 1 - pathman.dis
						pathman.walk = pathman.wantwalk
					elseif pathman.wantwalk == 2 and pathman.walk == 4 then
						pathman.y = pathman.y + 1
						if pathman.y > scale.datay then pathman.y = pathman.y - scale.datay end
						pathman.dis = 1 - pathman.dis
						pathman.walk = pathman.wantwalk
					elseif pathman.wantwalk == 4 and pathman.walk == 2 then
						pathman.y = pathman.y - 1
						if pathman.y < 0 then pathman.y = pathman.y + scale.datay end
						pathman.dis = 1 - pathman.dis
						pathman.walk = pathman.wantwalk
					end
				end
			else
				if block[field[pathman.x][pathman.y]][pathman.wantwalk] == true then
					pathman.walk = pathman.wantwalk
				end
			end
		end
		pathman.values.walk = pathman.walk
		pathman.values = amnag.pathman.update(pathman.values,dt)
		
		AI.calculate(pacmans,field,pathman,dt * playspeed.value)
		
		local x1,y1 = posWithWalkDis(pathman.x,pathman.y,pathman.walk,pathman.dis)
		
		local tr = {}
		for pac = 1, table.getn(pacmans) do
			local x2,y2 = posWithWalkDis(pacmans[pac].x,pacmans[pac].y,pacmans[pac].walk,pacmans[pac].dis)
			if amnag.math.distance(x1,y1,x2,y2) <= 0.7 then
				if pathman.chasetime > 0 then
					table.insert(tr,pac)
				else
					FAIL()
					break
				end
			end
		end
		
		for i = 1, table.getn(tr) do
			table.remove(pacmans,tr[i])
		end
		
		if pathman == nil then else
			if points[pathman.x][pathman.y] == nil then
				--error("FUCK YOU")
			elseif points[pathman.x][pathman.y] > 0 then
				if points[pathman.x][pathman.y] == 2 then
					if amnag.math.distance(x1,y1,pathman.x,pathman.y) < 0.7 then
						points[pathman.x][pathman.y] = 0
						score = score + 2
						pathman.chasetime = 10
					end
				elseif amnag.math.distance(x1,y1,pathman.x,pathman.y) < 0.5 then
					points[pathman.x][pathman.y] = 0
					score = score + 1
				end
			end
			if pathman.walk == 1 then
				local xx = pathman.x - 1
				if xx == 0 then xx = xx + scale.datax end
				if points[xx][pathman.y] > 0 then
					if points[xx][pathman.y] == 2 then
						if amnag.math.distance(x1,y1,pathman.x - 1,pathman.y) < 0.7 then
							points[xx][pathman.y] = 0
							score = score + 2
							pathman.chasetime = 10
						end
					elseif amnag.math.distance(x1,y1,pathman.x - 1,pathman.y) < 0.5 then
						points[xx][pathman.y] = 0
						score = score + 1
					end
				end
			elseif pathman.walk == 2 then
				local yy = pathman.y - 1
				if yy == 0 then yy = yy + scale.datay end
				if points[pathman.x][yy] > 0 then
					if points[pathman.x][yy] == 2 then
						if amnag.math.distance(x1,y1,pathman.x,pathman.y - 1) < 0.7 then
							points[pathman.x][yy] = 0
							score = score + 2
							pathman.chasetime = 10
						end
					elseif amnag.math.distance(x1,y1,pathman.x,pathman.y - 1) < 0.5 then
						points[pathman.x][yy] = 0
						score = score + 1
					end
				end
			elseif pathman.walk == 3 then
				local xx = pathman.x + 1
				if xx == scale.datax + 1 then xx = xx - scale.datax end
				if points[xx][pathman.y] > 0 then
					if points[xx][pathman.y] == 2 then
						if amnag.math.distance(x1,y1,pathman.x + 1,pathman.y) < 0.7 then
							points[xx][pathman.y] = 0
							score = score + 2
							pathman.chasetime = 10
						end
					elseif amnag.math.distance(x1,y1,pathman.x + 1,pathman.y) < 0.5 then
						points[xx][pathman.y] = 0
						score = score + 1
					end
				end
			elseif pathman.walk == 4 then
				local yy = pathman.y + 1
				if yy == scale.datay + 1 then yy = yy - scale.datay end
				if points[pathman.x][yy] > 0 then
					if points[pathman.x][yy] == 2 then
						if amnag.math.distance(x1,y1,pathman.x,pathman.y + 1) < 0.7 then
							points[pathman.x][yy] = 0
							score = score + 2
							pathman.chasetime = 10
						end
					elseif amnag.math.distance(x1,y1,pathman.x,pathman.y + 1) < 0.5 then
						points[pathman.x][yy] = 0
						score = score + 1
					end
				end
			end
		end
	elseif gamemode == "menu" then
		for b = 1, table.getn(buttons) do
			if mouse_x > buttons[b].x and mouse_y > buttons[b].y and mouse_x < buttons[b].x + buttons[b].width and mouse_y < buttons[b].y + buttons[b].height then
				buttons[b].held = true
			else
				buttons[b].held = false
			end
		end
	elseif gamemode == "play" then
		for b = 1, table.getn(playbutton) do
			if mouse_x > playbutton[b].x and mouse_y > playbutton[b].y and mouse_x < playbutton[b].x + playbutton[b].width and mouse_y < playbutton[b].y + playbutton[b].height then
				playbutton[b].held = true
			else
				playbutton[b].held = false
			end
		end
		if playspeed.held == true then
			playspeed.move(math.delerp(100,700,mouse_x + playspeed.offset))
		end
	elseif gamemode == "credits" then
		if mouse_x > credbutton.x and mouse_y > credbutton.y and mouse_x < credbutton.x + credbutton.width and mouse_y < credbutton.y + credbutton.height then
			credbutton.held = true
		else
			credbutton.held = false
		end
		if credits.held == true then
			credits.tmpscroll = mouse_y - credits.mouseclick.y
		else
			credits.scroll = credits.scroll + credits.tmpscroll
			credits.tmpscroll = 0
		end
		if credits.scroll + credits.tmpscroll > 0 then
			credits.tmpscroll = 0 - credits.scroll
		elseif credits.scroll + credits.tmpscroll < -465 then
			credits.tmpscroll = -465 - credits.scroll
		end
	elseif gamemode == "extras" then
		extras.update(dt)
	end
end

function FAIL()
	gamemode = "menu"
	field = nil
	points = nil
	pacmans = nil
	scale = nil
	pathman = nil
end

function love.mousereleased(x,y,button)
	if gamemode == "play" then
		playspeed.held = false
	elseif gamemode == "credits" then
		--credits.mouseclick = {x = x,y = y}
		credits.held = false
		--credits.scroll = credits.scroll - credits.tmpscroll
	end
end

function love.mousepressed(x,y,button)
	if gamemode == "game" then
		if button == "l" then
			pathman.path = {math.ceil(x / (screen.width / scale.datax)),math.ceil(y / (screen.height / scale.datay))}
			pathman.pathing = true
		end
		if button == "l" then
			if points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] == 2 then
				points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = 0
			else
				points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] + 1
			end
		elseif button == "r" then
			if points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] == 0 then
				points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = 2
			else
				points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = points[math.ceil(x / scale.x)][math.ceil(y / scale.y)] - 1
			end
		elseif button == "wd" then
			if field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] == table.getn(block) then
				field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = 0
			else
				field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] + 1
			end
		elseif button == "wu" then
			if field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] == 0 then
				field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = table.getn(block)
			else
				field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] = field[math.ceil(x / scale.x)][math.ceil(y / scale.y)] - 1
			end
		end
	elseif gamemode == "menu" then
		for b = 1, table.getn(buttons) do
			if x > buttons[b].x and y > buttons[b].y and x < buttons[b].x + buttons[b].width and y < buttons[b].y + buttons[b].height then
				buttons[b].func()
			end
		end
	elseif gamemode == "play" then
		for b = 1, table.getn(playbuttons) do
			if x > playbuttons[b].x and y > playbuttons[b].y and x < playbuttons[b].x + playbuttons[b].width and y < playbuttons[b].y + playbuttons[b].height then
				playbuttons.pick = b --[b].func()
			end
		end
		for b = 1, table.getn(playbutton) do
			if x > playbutton[b].x and y > playbutton[b].y and x < playbutton[b].x + playbutton[b].width and y < playbutton[b].y + playbutton[b].height then
				playbutton[b].func()
			end
		end
		for b = 1, table.getn(mapselection) do
			if x > mapselection[b].x and y > mapselection[b].y and x < mapselection[b].x + mapselection[b].width and y < mapselection[b].y + mapselection[b].height then
				mapselection.pick = b
			end
		end
		if amnag.math.distance(100 + math.lerp(0,playspeed.width,math.delerp(playspeed.lvalue,playspeed.tvalue,playspeed.value)),playspeed.y,mouse_x,mouse_y) < 16 then
			playspeed.held = true
			playspeed.offset = mouse_x - math.lerp(0,playspeed.width,math.delerp(playspeed.lvalue,playspeed.tvalue,playspeed.value)) - 100
		end
	elseif gamemode == "credits" then
		if x > credbutton.x and y > credbutton.y and x < credbutton.x + credbutton.width and y < credbutton.y + credbutton.height then
			credbutton.func()
		else
			credits.mouseclick = {x = x,y = y}
			credits.held = true
		end
	elseif gamemode == "extras" then
		extras.mousepressed(x,y,button)
	end
end

function love.keypressed(k)
	if gamemode == "game" then
		if k == "escape" then
			gamemode = "menu"
		end
		if k == "m" then
			mode = not mode
		elseif k == "n" then
			points.display = not points.display
		elseif k == "s" then
			--table.save(points,"point" .. file )
			--table.save(field,"field" .. file )
			file = file + 1
		end
	end
end

function even(number)
	if math.floor(number / 2) * 2 == number then
		return true
	else
		return false
	end
end

function math.round(a)
	return math.floor(a + 0.5)
end

function love.draw()
	if gamemode == "game" then
		if mode == false then
			for x = 1, scale.datax do
				for y = 1, scale.datay do
					love.graphics.setColor(255,255,255,255)
					if block[field[x][y]][1] == false then
						love.graphics.rectangle("fill",scale.x * (x - 1),scale.y * (y - 1),scale.x * 0.1,scale.y)
					end
					if block[field[x][y]][2] == false then
						love.graphics.rectangle("fill",scale.x * (x - 1),scale.y * (y - 1),scale.x,scale.y * 0.1)
					end
					if block[field[x][y]][3] == false then
						love.graphics.rectangle("fill",scale.x * (x - 0.1),scale.y * (y - 1),scale.x * 0.1,scale.y)
					end
					if block[field[x][y]][4] == false then
						love.graphics.rectangle("fill",scale.x * (x - 1),scale.y * (y - 0.1),scale.x,scale.y * 0.1)
					end
					if points[x][y] == 1 then
						love.graphics.setColor(0,255,0,255)
						love.graphics.circle("fill",scale.x * (x - 0.5),scale.y * (y - 0.5),math.min(scale.x,scale.y) * 0.15,scale.datax)
					elseif points[x][y] == 2 then
						love.graphics.setColor(0,255,0,255)
						love.graphics.circle("fill",scale.x * (x - 0.5),scale.y * (y - 0.5),math.min(scale.x,scale.y) * 0.3,scale.datax)
					end
				end
			end
			love.graphics.setColor(255,255,255,255)
			for x = 0, scale.datax do
				for y = 0, scale.datay do
					love.graphics.circle("fill",scale.x * (x),scale.y * (y),math.min(scale.x,scale.y) * 0.1,scale.datax)
				end
			end
		elseif points.display == true then
			love.graphics.setColor(255,255,255,255)
			for x = 1, scale.datax do
				for y = 1, scale.datay do
					love.graphics.print(""..points[x][y],scale.x * (x - 0.5) - (love.graphics.getFont():getWidth(""..points[x][y]) / 2),scale.y * (y - 0.5) - (love.graphics.getFont():getHeight() / 2))
					--love.graphics.print(""..pacmans[1].navigator[x][y],scale.x * (x - 0.5) - (love.graphics.getFont():getWidth(""..pacmans[1].navigator[x][y]) / 2),scale.y * (y - 0.5) - (love.graphics.getFont():getHeight() / 2))
				end
			end
		else
			love.graphics.setColor(255,255,255,255)
			for x = 1, scale.datax do
				for y = 1, scale.datay do
					love.graphics.print(""..field[x][y],scale.x * (x - 0.5) - (love.graphics.getFont():getWidth(""..field[x][y]) / 2),scale.y * (y - 0.5) - (love.graphics.getFont():getHeight() / 2))
				end
			end
		end
		love.graphics.setColor(0,0,255,255)
		local x = scale.x * (pathman.x - 0.5)
		local y = scale.y * (pathman.y - 0.5)
		if pathman.walk == 1 then
			x = x - (scale.x * pathman.dis)
		elseif pathman.walk == 2 then
			y = y - (scale.y * pathman.dis)
		elseif pathman.walk == 3 then
			x = x + (scale.x * pathman.dis)
		elseif pathman.walk == 4 then
			y = y + (scale.y * pathman.dis)
		end
		amnag.pathman.animate(x,y,pathman.values,0.35 * math.min(scale.x,scale.y))
		amnag.pathman.animate(800 + x,y,pathman.values,0.35 * math.min(scale.x,scale.y))
		amnag.pathman.animate(x,600 + y,pathman.values,0.35 * math.min(scale.x,scale.y))
		amnag.pathman.animate(x - 800,y,pathman.values,0.35 * math.min(scale.x,scale.y))
		amnag.pathman.animate(x,y - 600,pathman.values,0.35 * math.min(scale.x,scale.y))
		--love.graphics.setColor(255,255,0,255)
		for pac = 1, table.getn(pacmans) do
			--love.graphics.setColor(0,255,0,128)
			--love.graphics.rectangle("fill",scale.x * (pacmans[pac].x - 1),scale.y * (pacmans[pac].y - 1),scale.x,scale.y)
			local x = scale.x * (pacmans[pac].x - 0.5)
			local y = scale.y * (pacmans[pac].y - 0.5)
			if pacmans[pac].walk == 1 then
				x = x - (scale.x * pacmans[pac].dis)
			elseif pacmans[pac].walk == 2 then
				y = y - (scale.y * pacmans[pac].dis)
			elseif pacmans[pac].walk == 3 then
				x = x + (scale.x * pacmans[pac].dis)
			elseif pacmans[pac].walk == 4 then
				y = y + (scale.y * pacmans[pac].dis)
			end
			ghost.animate(x,y,pacmans[pac].values,0.35 * math.min(scale.x,scale.y))
			ghost.animate(800 + x,y,pacmans[pac].values,0.35 * math.min(scale.x,scale.y))
			ghost.animate(x,600 + y,pacmans[pac].values,0.35 * math.min(scale.x,scale.y))
			ghost.animate(x - 800,y,pacmans[pac].values,0.35 * math.min(scale.x,scale.y))
			ghost.animate(x,y - 600,pacmans[pac].values,0.35 * math.min(scale.x,scale.y))
		end
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("SCORE: " .. score,20,20)
	elseif gamemode == "menu" then
		for b = 1, table.getn(buttons) do
			love.graphics.setColor(255,255,255,255)
			if buttons[b].held == true then
				love.graphics.rectangle("fill",buttons[b].x,buttons[b].y,buttons[b].width,buttons[b].height)
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(buttons[b].text.held,buttons[b].x + buttons[b].width / 2 - love.graphics.getFont():getWidth(buttons[b].text.held) / 2,buttons[b].y + buttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			else
				love.graphics.rectangle("line",buttons[b].x,buttons[b].y,buttons[b].width,buttons[b].height)
				love.graphics.print(buttons[b].text.left,buttons[b].x + buttons[b].width / 2 - love.graphics.getFont():getWidth(buttons[b].text.left) / 2,buttons[b].y + buttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			end
		end
		love.graphics.setColor(255,255,255,255)
	elseif gamemode == "play" then
		love.graphics.setColor(255,255,255,255)
		
		lrpd = math.lerp(0,playspeed.width,math.delerp(playspeed.lvalue,playspeed.tvalue,playspeed.value))
		
		love.graphics.line(math.min(playspeed.x,lrpd + playspeed.x - 16),playspeed.y,playspeed.x + lrpd - 16,playspeed.y)
		love.graphics.line(playspeed.x + lrpd + 16,playspeed.y,math.max(playspeed.x + playspeed.width,playspeed.x + lrpd + 16),playspeed.y)
		
		love.graphics.circle("line",playspeed.x + lrpd,playspeed.y,16,32)
		love.graphics.print(math.round(playspeed.value * 100) / 100,playspeed.x + lrpd - love.graphics.getFont():getWidth(math.round(playspeed.value * 100) / 100) / 2,playspeed.y - love.graphics.getFont():getHeight() / 2)
		for b = 1, table.getn(playbuttons) do
			love.graphics.setColor(255,255,255,255)
			if b == playbuttons.pick then
				love.graphics.rectangle("fill",playbuttons[b].x,playbuttons[b].y,playbuttons[b].width,playbuttons[b].height)
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(playbuttons[b].text.held,playbuttons[b].x + playbuttons[b].width / 2 - love.graphics.getFont():getWidth(playbuttons[b].text.held) / 2,playbuttons[b].y + playbuttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			else
				love.graphics.rectangle("line",playbuttons[b].x,playbuttons[b].y,playbuttons[b].width,playbuttons[b].height)
				love.graphics.print(playbuttons[b].text.left,playbuttons[b].x + playbuttons[b].width / 2 - love.graphics.getFont():getWidth(playbuttons[b].text.left) / 2,playbuttons[b].y + playbuttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			end
		end
		for b = 1, table.getn(playbutton) do
			love.graphics.setColor(255,255,255,255)
			if playbutton[b].held == true then
				love.graphics.rectangle("fill",playbutton[b].x,playbutton[b].y,playbutton[b].width,playbutton[b].height)
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(playbutton[b].text.held,playbutton[b].x + playbutton[b].width / 2 - love.graphics.getFont():getWidth(playbutton[b].text.held) / 2,playbutton[b].y + playbutton[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			else
				love.graphics.rectangle("line",playbutton[b].x,playbutton[b].y,playbutton[b].width,playbutton[b].height)
				love.graphics.print(playbutton[b].text.left,playbutton[b].x + playbutton[b].width / 2 - love.graphics.getFont():getWidth(playbutton[b].text.left) / 2,playbutton[b].y + playbutton[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			end
		end
		for b = 1, table.getn(mapselection) do
			love.graphics.setColor(255,255,255,255)
			if b == mapselection.pick then
				love.graphics.rectangle("fill",mapselection[b].x,mapselection[b].y,mapselection[b].width,mapselection[b].height)
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(mapselection[b].text.held,mapselection[b].x + mapselection[b].width / 2 - love.graphics.getFont():getWidth(mapselection[b].text.held) / 2,mapselection[b].y + mapselection[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			else
				love.graphics.rectangle("line",mapselection[b].x,mapselection[b].y,mapselection[b].width,mapselection[b].height)
				love.graphics.print(mapselection[b].text.left,mapselection[b].x + mapselection[b].width / 2 - love.graphics.getFont():getWidth(mapselection[b].text.left) / 2,mapselection[b].y + mapselection[b].height / 2 - love.graphics.getFont():getHeight() / 2)
			end
		end
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("Preview",400 - love.graphics.getFont():getWidth("Preview") / 2,360)
		--love.graphics.rectangle("line",200 + 50 * (4 / 3),390,200 * (4 / 3),200)
		
		-- PREVIEW
		local previewx = 200 + 50 * (4 / 3)
		local previewy = 390
		for x = 0, amnag.map[mapselection.pick].scale.datax do
			for y = 0, amnag.map[mapselection.pick].scale.datay do
				if x == 0 or y == 0 then else
					love.graphics.setColor(255,255,255,255)
					if block[amnag.map[mapselection.pick].field[x][y]][1] == false then
						love.graphics.rectangle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 1),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 1),amnag.map[mapselection.pick].scale.x / 3 * 0.1,amnag.map[mapselection.pick].scale.y / 3)
					end
					if block[amnag.map[mapselection.pick].field[x][y]][2] == false then
						love.graphics.rectangle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 1),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 1),amnag.map[mapselection.pick].scale.x / 3,amnag.map[mapselection.pick].scale.y / 3 * 0.1)
					end
					if block[amnag.map[mapselection.pick].field[x][y]][3] == false then
						love.graphics.rectangle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 0.1),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 1),amnag.map[mapselection.pick].scale.x / 3 * 0.1,amnag.map[mapselection.pick].scale.y / 3)
					end
					if block[amnag.map[mapselection.pick].field[x][y]][4] == false then
						love.graphics.rectangle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 1),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 0.1),amnag.map[mapselection.pick].scale.x / 3,amnag.map[mapselection.pick].scale.y / 3 * 0.1)
					end
					love.graphics.setColor(0,255,0,255)
					if amnag.map[mapselection.pick].pointmap[1][x][y] == 1 then
						love.graphics.circle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 0.5),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 0.5),math.min(amnag.map[mapselection.pick].scale.x / 3,amnag.map[mapselection.pick].scale.y / 3) * 0.15,amnag.map[mapselection.pick].scale.datax)
					elseif amnag.map[mapselection.pick].pointmap[1][x][y] == 2 then
						love.graphics.circle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x - 0.5),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y - 0.5),math.min(amnag.map[mapselection.pick].scale.x / 3,amnag.map[mapselection.pick].scale.y / 3) * 0.3,amnag.map[mapselection.pick].scale.datax)
					end
				end
				love.graphics.setColor(255,255,255,255)
				love.graphics.circle("fill",previewx + amnag.map[mapselection.pick].scale.x / 3 * (x),previewy + amnag.map[mapselection.pick].scale.y / 3 * (y),math.min(amnag.map[mapselection.pick].scale.x / 3,amnag.map[mapselection.pick].scale.y / 3) * 0.1,amnag.map[mapselection.pick].scale.datax)
			end
		end
		love.graphics.setColor(255,0,0,255)
		love.graphics.setLineWidth(1)
		love.graphics.rectangle("line",previewx - 1,previewy - 1,200 * (4 / 3) + 2,202)
		
	elseif gamemode == "credits" then
		love.graphics.setColor(255,255,255,255)
		if credbutton.held == true then
			love.graphics.rectangle("fill",credbutton.x,credbutton.y,credbutton.width,credbutton.height)
			love.graphics.setColor(0,0,0,255)
			love.graphics.print(credbutton.text.held,credbutton.x + credbutton.width / 2 - love.graphics.getFont():getWidth(credbutton.text.held) / 2,credbutton.y + credbutton.height / 2 - love.graphics.getFont():getHeight() / 2)
		else
			love.graphics.rectangle("line",credbutton.x,credbutton.y,credbutton.width,credbutton.height)
			love.graphics.print(credbutton.text.left,credbutton.x + credbutton.width / 2 - love.graphics.getFont():getWidth(credbutton.text.left) / 2,credbutton.y + credbutton.height / 2 - love.graphics.getFont():getHeight() / 2)
		end
		love.graphics.setColor(255,255,255,255)
		for i = 1, table.getn(credits) do
			love.graphics.print(credits[i],400 - love.graphics.getFont():getWidth(credits[i]) / 2,25 + credits.scroll + credits.tmpscroll + i * 25)
		end
	elseif gamemode == "extras" then
		extras.draw()
	end
	--amnag.graphics.drawLightning(light)
end
