amnag.pathman = {}

amnag.pathman.values = function()
	return {
		anim_state = 0,
		walk = 0,
		afraid = false,
	}
end

amnag.pathman.update = function(vals,dt)
	vals.anim_state = vals.anim_state + dt
	if vals.anim_state > 1 then
		vals.anim_state = vals.anim_state - 1
	end
	return vals
end

amnag.pathman.animate = function(x,y,vals,scale)
	love.graphics.setColor(255,165,0,255)
	anim_state = vals.anim_state * 2
	local gst = {}
	local tbl1 = {}
	local tbl2 = {}
	local pip = math.pi / 10
	for i = 0, 20 do
		if even(i) then
			table.insert(gst,x + (math.cos(math.pi + (pip * i) + pip * anim_state) * scale * 0.85))
			table.insert(gst,y + (math.sin(math.pi + (pip * i) + pip * anim_state) * scale * 0.85))
			table.insert(tbl1,{x + (math.cos(math.pi + (pip * i) + pip * anim_state) * scale * 0.85),y + (math.sin(math.pi + (pip * i) + pip * anim_state) * scale * 0.85)})
		else
			table.insert(gst,x + (math.cos(math.pi + (pip * i) + pip * anim_state) * scale * 1.15))
			table.insert(gst,y + (math.sin(math.pi + (pip * i) + pip * anim_state) * scale * 1.15))
			table.insert(tbl2,{x + (math.cos(math.pi + (pip * i) + pip * anim_state) * scale * 1.15),y + (math.sin(math.pi + (pip * i) + pip * anim_state) * scale * 1.15)})
		end
	end
	local plg = {}
	for i = 1, table.getn(tbl2) do
		for j = 0.1,1,0.1 do
			local tmpi = i + 1
			if i > table.getn(tbl1) then tmpi = 1 end
			local x1,y1 = amnag.math.bendpoint(tbl1[i][1],tbl1[i][2],tbl2[i][1],tbl2[i][2],tbl1[tmpi][1],tbl1[tmpi][2],j)
			table.insert(plg,x1)
			table.insert(plg,y1)
		end
	end
	love.graphics.setLineWidth(0.1 * scale)
	love.graphics.polygon("fill",plg)
	love.graphics.setColor(0,0,0,255)
	love.graphics.polygon("line",plg)
	love.graphics.setLineWidth(0.05 * scale)
	if vals.walk == 1 then
		
		-- EYE LEFT
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.3 * scale,y - 0.3 * scale,0.15 * scale,0.1 * scale,32)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.25 * scale,y - 0.3 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x - 0.3 * scale,y - 0.3 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		-- EYE RIGHT
		
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.25 * scale,y - 0.25 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x + 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		amnag.graphics.oval("fill",x - 0.6 * scale,y + 0.3 * scale,0.20 * scale,0.40 * scale,32)
		amnag.graphics.bend(x - 0.6 * scale,y + 0.7 * scale,(x - 0.6 * scale + x + -0.1 * scale) / 2,y + 0.5 * scale,x + -0.1 * scale,y + 0.5 * scale,16)
		amnag.graphics.bend(x - 0.6 * scale,y - 0.1 * scale,(x - 0.6 * scale + x + -0.1 * scale) / 2,y - -0.1 * scale,x + -0.1 * scale,y - -0.1 * scale,16)
	elseif vals.walk == 2 then
		
	elseif vals.walk == 3 then
		
		-- EYE LEFT
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,23)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.25 * scale,y - 0.25 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x - 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		-- EYE RIGHT
		
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.3 * scale,y - 0.3 * scale,0.15 * scale,0.1 * scale,32)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.25 * scale,y - 0.3 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x + 0.3 * scale,y - 0.3 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		amnag.graphics.oval("fill",x + 0.6 * scale,y + 0.3 * scale,0.20 * scale,0.40 * scale,32)
		amnag.graphics.bend(x + 0.6 * scale,y + 0.7 * scale,(x + 0.6 * scale + x - -0.1 * scale) / 2,y + 0.5 * scale,x - -0.1 * scale,y + 0.5 * scale,16)
		amnag.graphics.bend(x + 0.6 * scale,y - 0.1 * scale,(x + 0.6 * scale + x - -0.1 * scale) / 2,y - -0.1 * scale,x - -0.1 * scale,y - -0.1 * scale,16)
	elseif vals.walk == 4 or vals.walk == 0 then
		-- EYE LEFT
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x - 0.25 * scale,y - 0.25 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x - 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x - 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		-- EYE RIGHT
		
		love.graphics.setColor(255,255,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		love.graphics.setColor(255,255,255,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		love.graphics.setColor(0,0,0,255) -- FILLING
		amnag.graphics.oval("fill",x + 0.25 * scale,y - 0.25 * scale,0.1 * scale,0.08 * scale,32)
		
		love.graphics.setColor(0,0,0,255) -- LINING
		amnag.graphics.oval("line",x + 0.3 * scale,y - 0.27 * scale,0.15 * scale,0.1 * scale,32)
		amnag.graphics.oval("line",x + 0.4 * scale,y - 0.3 * scale,0.3 * scale,0.25 * scale,32)
		
		amnag.graphics.oval("fill",x,y + 0.3 * scale,0.35 * scale,0.40 * scale,32)
	end
	--love.graphics.polygon("line",gst)
end
